-- sort.lua
-- Written By MrJackdaw, tweak by Habna for HugeBag


FailSafeTimer = Turbine.UI.Control();
SortTimer = Turbine.UI.Control();

function Sort()
	if IsSorting or IsMixing or IsMerging or IsSearching then
		write( L["FSSortE"] );
		return
	end

	IsSorting = true;
	ButtonsCtr:SetVisible( false );
	FirstStart = Turbine.Engine.GetGameTime();
	Start = Turbine.Engine.GetGameTime();
	lastfoundat, x = nil, backpackSize;
	WasMoved = {};
	
	FailSafe(); --Enable/Disable Fail safe
	SortHugeBag();
end

function SortHugeBag()	
	CreateVirtualPack();

	Slot = 1;
	write( L["FSSortS"] );

	SortTimer.Update = function( sender, args )
		if Slot > backpackSize then -- Stop when last slot is reached
			write("Sort Method 2 finish");
			SortTimer:SetWantsUpdates( false );
			FailSafeTimer:SetWantsUpdates( false );

			if ShowButton then ButtonsCtr:SetVisible( true ); end
	
			IsSorting = false;
			write( L["FSSortF"] );
			local Time = Turbine.Engine.GetGameTime();
			write("<rgb=#888888>" .. L["Sort"] .. L["FAMergeFA"] .. string.format( "%.2f", Time - FirstStart ) .. L["FAMergeSec"] )
		else
			--Get the quantity & name of the target item
			targetName = VirtPack[Slot].Name;
			target = VirtPack[Slot].Quantity .. " " .. targetName;
		
			--Search the target item in bag.
			for i = Slot, backpackSize do
				item = Backpack:GetItem( i );

				if item ~= nil then
					itemName = item:GetName();
					itemQuantity = item:GetQuantity();
				else
					itemName = "zEmpty";
					itemQuantity = 0;
				end
				source = itemQuantity .. " " .. itemName;
				--write(source .. " / " .. target);
				if source == target then
					if i == Slot then Slot = Slot + 1 return end
					--write(source .. " found at " .. i .. " / Slot " .. Slot .. ": " .. target);
					-- Check if item in destination slot is not the same item that will go there, cause if true them a merge will
					-- be perform and sort will not end properly, making button not visible and can't perform sort again.
					local ditem = Backpack:GetItem( Slot );
					if ditem ~= nil then
						ditemName = ditem:GetName();
						ditemMaxStackSize = ditem:GetMaxStackSize(); -- if max = 1 then it's not stackable
						--write("Slot: " .. i .. " item max stack size is : " .. ditemMaxStackSize);
						--write(ditemName .. " / " .. itemName);
						if ditemName == itemName then
							-- check if destination item is stackable
							--write(ditemMaxStackSize);
							if ditemMaxStackSize > 1 then
								--write("Moving item in " .. Slot .. " to a free slot");
								-- Yes it's stackable and same name. Move it to an empty slot
								local found = false;
								for FreeSlot = Slot + 1, backpackSize do
									local freeLoc = Backpack:GetItem( FreeSlot );
									if freeLoc == nil then -- Free space found
										found = true;
										--write("Free slot found at " .. FreeSlot);
										Backpack:PerformItemDrop(ditem, FreeSlot, false);
										break
									end
								end
								--write("Found: " .. tostring(found));
								-- No free slot was found in bag, move to next slot that is not same item name
								if not found then
									--write("No free slot available. Moving to next slot");
									for NextSlot = Slot + 1, backpackSize do
										--write(tostring(NextSlot));
										local nextItem = Backpack:GetItem( NextSlot );
										if nextItem ~= nil then
											nitemName = nextItem:GetName();
											if nitemName ~= ditemName then
												Backpack:PerformItemDrop(ditem, NextSlot, false);
												break
											end
										end
									end
								end
							end
						end
					end
					
					if Lasti == i then
						Lasti = nil;
						i = i - 1;
					else
						if item ~= nil then
							--write("Performing item drop to slot " .. i);
							Backpack:PerformItemDrop(item, Slot, false);
							Lasti = i; --Last item move (slot number)
							Slot = Slot + 1;
							return
						end
					end
				end
			end
		end
	end

	SortTimer:SetWantsUpdates( true );
end

function FailSafe()
	NumSecs = 0;
	MaxSecs = 15; --Number of seconds before fail safe reload HugeBag. (In case sort fail to finish within it's allowed time)

	FailSafeTimer.Update = function( sender, args )
		currentdate = Turbine.Engine.GetDate();
		currentsecond = currentdate.Second;

		if NumSecs > MaxSecs then --Stop the sorting if it take more then it's allowed secs to complete.
			write( L["FSSortFS"] .. MaxSecs .. L["FAMergeSec"]);

			FailSafeTimer:SetWantsUpdates( false );
			SortTimer:SetWantsUpdates( false );

			if ShowButton then ButtonsCtr:SetVisible( true ); end
	
			IsSorting = false;
			--ReloadHugeBag();
		else
			if (oldsecond ~= currentsecond) then --Add 1 to NumSecs every real second
				oldsecond = currentsecond;
				NumSecs = NumSecs + 1;
			end
		end
	end

	FailSafeTimer:SetWantsUpdates( true );
end